"use strict";
{
    const C3 = self.C3;

    C3.Plugins.EMI_INDO_ALLFirebase.Instance = class ALLFirebaseInstance extends C3.SDKInstanceBase
    {
        constructor(inst, properties)
        {
            super(inst);


            if (properties)
            {
                this.SERVER_CLIENT_ID = properties[0];
            }


            if (typeof FirebasePlugin == 'undefined')
            {
                return;
            }
            else
            {};


            this.EMI_INDO = C3.Plugins.EMI_INDO_ALLFirebase.Cnds;

            const SERVER_CLIENT_ID = this.SERVER_CLIENT_ID;


            this.logE = "";
            this.logS = "";

            const self = this;
            // Fake authentication code as defined in the Firebase Console: see https://firebase.google.com/docs/auth/android/phone-auth#integration-testing
            var FAKE_SMS_VERIFICATION_CODE = '123456';

            // UI logging

            const prependLogMessage = a => {
                {
                    document['output']['prepend']('<span\x20class=\x22' + (a['logLevel'] ? a['logLevel'] : '') + '\x22>' + a['msg'] + '</span>' + (a['nobreak'] ? '<br/>' : '<br/><br/>'));
                };
            };
            let log = (a, b) => {
                {
                    b = b || {};
                    b['logLevel'] = b['logLevel'] || 'log';
                    console[b['logLevel']](a);
                    b['msg'] = a;
                    self['logS'] = b['logLevel'] || 'log';
                    self['logS'] = a;
                    prependLogMessage(b);
                };
            };
            let logError = (a, b) => {
                {
                    if (typeof b === 'object')
                    {
                        a += ':\x20' + JSON['stringify'](b);
                        self['logE'] = a += ':\x20' + JSON['stringify'](b);
                    }
                    else if (typeof b === 'string')
                    {
                        a += ':\x20' + b;
                        self['logE'] = a += ':\x20' + b;
                    }
                    log(a,
                    {
                        'logLevel': 'error'
                    });
                };
            };
            const clearLog = () => {
                {
                    output['empty']();
                };
            };
            const promptUserForInput = (a, b, c) => {
                {
                    navigator['notification']['prompt'](b, function(d)
                    {
                        var e = d['input1'] || '';
                        c(e['trim']());
                    }, a, ['Ok']);
                }
            };
            let appRootURL = window['location']['href']['replace']('index.html', '');
            window['onerror'] = function(a, b, c, d, e)
            {
                let f = a;
                let g = null;
                let h = function()
                {
                    FirebasePlugin['logError'](f, g, function()
                    {
                        log('Sent\x20JS\x20exception\x20trace');
                    }, function(i)
                    {
                        logError('Failed\x20to\x20send\x20JS\x20exception\x20trace', i);
                    });
                };
                f += ':\x20url=' + b['replace'](appRootURL, '') + ';\x20line=' + c + ';\x20col=' + d;
                if (e && typeof e === 'object')
                {
                    StackTrace['fromError'](e)['then'](function(i)
                    {
                        g = i;
                        h();
                    });
                }
                else
                {
                    h();
                }
            };
            const RegisterHandlers = () => {
                FirebasePlugin['onMessageReceived'](function(a)
                {
                    try
                    {
                        console['log']('onMessageReceived');
                        console['dir'](a);
                        if (a['messageType'] === 'notification')
                        {
                            handleNotificationMessage(a);
                        }
                        else
                        {
                            handleDataMessage(a);
                        }
                    }
                    catch (b)
                    {
                        logError('Exception\x20in\x20onMessageReceived\x20callback:\x20' + b['message']);
                    }
                }, function(a)
                {
                    logError('Failed\x20receiving\x20FirebasePlugin\x20message', a);
                });
                FirebasePlugin['onTokenRefresh'](function(a)
                {
                    log('Token\x20refreshed:\x20' + a);
                }, function(a)
                {
                    logError('Failed\x20to\x20refresh\x20token', a);
                });
                FirebasePlugin['registerAuthStateChangeListener'](function(a)
                {
                    log('Auth\x20state\x20changed:\x20User\x20signed\x20' + (a ? 'in' : 'out'));
                });
                cordova['plugin']['customfcmreceiver']['registerReceiver'](function(a)
                {
                    log('Received\x20custom\x20message:\x20' + a);
                });
            };
            const initAndroid = a => {
                var a = {
                    'id': 'my_channel_id',
                    'name': 'My\x20channel\x20name',
                    'sound': 'blackberry',
                    'vibration': [
            0x12c,
            0xc8,
            0x12c
        ],
                    'light': !! [],
                    'lightColor': '0xFF0000FF',
                    'importance': 0x4,
                    'badge': !! [],
                    'visibility': 0x1
                };
                FirebasePlugin['createChannel'](a, function()
                {
                    log('Created\x20custom\x20channel:\x20' + a['id']);
                    FirebasePlugin['listChannels'](function(b)
                    {
                        if (typeof b == 'undefined') return;
                        for (var c = 0x0; c < b['length']; c++)
                        {
                            log('Channel\x20id=' + b[c]['id'] + ';\x20name=' + b[c]['name']);
                        }
                    }, function(b)
                    {
                        logError('List\x20channels\x20error:\x20' + b);
                    });
                }, function(b)
                {
                    logError('Create\x20channel\x20error', b);
                });
            };
            const checkNotificationPermission = a => {
                FirebasePlugin['hasPermission'](function(b)
                {
                    if (b)
                    {
                        log('Remote\x20notifications\x20permission\x20granted');
                        getToken();
                    }
                    else if (!a)
                    {
                        log('Requesting\x20remote\x20notifications\x20permission');
                        FirebasePlugin['grantPermission'](checkNotificationPermission['bind'](this, !! []));
                    }
                    else
                    {
                        logError('Notifications\x20won\x27t\x20be\x20shown\x20as\x20permission\x20is\x20denied');
                    }
                });
            };
            const checkAutoInit = () => {
                FirebasePlugin['isAutoInitEnabled'](function(a)
                {
                    log('Auto\x20init\x20is\x20' + (a ? 'enabled' : 'disabled'));
                    document('body')['addClass']('autoinit-' + (a ? 'enabled' : 'disabled'))['removeClass']('autoinit-' + (a ? 'disabled' : 'enabled'));
                }, function(a)
                {
                    logError('Failed\x20to\x20check\x20auto\x20init', a);
                });
            };
            const enableAutoInit = () => {
                FirebasePlugin['setAutoInitEnabled']( !! [], function()
                {
                    log('Enabled\x20auto\x20init');
                    checkAutoInit();
                }, function(a)
                {
                    logError('Failed\x20to\x20enable\x20auto\x20init', a);
                });
            };
            const disableAutoInit = () => {
                FirebasePlugin['setAutoInitEnabled'](![], function()
                {
                    log('Disabled\x20auto\x20init');
                    checkAutoInit();
                }, function(a)
                {
                    logError('Failed\x20to\x20disable\x20auto\x20init', a);
                });
            };
            this['FCMID'] = '';
            const getID = () => {
                FirebasePlugin['getId'](function(a)
                {
                    log('Got\x20FCM\x20ID:\x20' + a);
                    self['FCMID'] = a;
                    self['Trigger'](C3['Plugins']['EMI_INDO_ALLFirebase']['Cnds']['Ongetid']);
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20FCM\x20ID', a);
                });
            };
            this['FCMtoken'] = '';
            const getToken = () => {
                FirebasePlugin['getToken'](function(a)
                {
                    log('Got\x20FCM\x20token:\x20' + a);
                    self['FCMtoken'] = a;
                    self['Trigger'](C3['Plugins']['EMI_INDO_ALLFirebase']['Cnds']['Ongettoken']);
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20FCM\x20token', a);
                });
            };
            this['APNStoken'] = '';
            const getAPNSToken = () => {
                FirebasePlugin['getAPNSToken'](function(a)
                {
                    log('Got\x20APNS\x20token:\x20' + a);
                    self['APNStoken'] = a;
                    self['Trigger'](C3['Plugins']['EMI_INDO_ALLFirebase']['Cnds']['Ongetapnstoken']);
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20APNS\x20token', a);
                });
            };
            const handleNotificationMessage = a => {
                var b;
                if (a['title'])
                {
                    b = a['title'];
                }
                else if (a['notification'] && a['notification']['title'])
                {
                    b = a['notification']['title'];
                }
                else if (a['aps'] && a['aps']['alert'] && a['aps']['alert']['title'])
                {
                    b = a['aps']['alert']['title'];
                }
                var c;
                if (a['body'])
                {
                    c = a['body'];
                }
                else if (a['notification'] && a['notification']['body'])
                {
                    c = a['notification']['body'];
                }
                else if (a['aps'] && a['aps']['alert'] && a['aps']['alert']['body'])
                {
                    c = a['aps']['alert']['body'];
                }
                var d = 'Notification\x20message\x20received';
                if (a['tap'])
                {
                    d += '\x20(tapped\x20in\x20' + a['tap'] + ')';
                }
                if (b)
                {
                    d += ';\x20title=' + b;
                }
                if (c)
                {
                    d += ';\x20body=' + c;
                }
                d += ':\x20' + JSON['stringify'](a);
                log(d);
            };
            const handleDataMessage = a => {
                log('Data\x20message\x20received:\x20' + JSON['stringify'](a));
            };
            const clearNotifications = () => {
                FirebasePlugin['clearAllNotifications'](function()
                {
                    log('Cleared\x20all\x20notifications');
                }, function(a)
                {
                    logError('Failed\x20to\x20clear\x20notifications', a);
                });
            };
            const subscribe = () => {
                FirebasePlugin['subscribe']('my_topic', function()
                {
                    log('Subscribed\x20to\x20topic');
                }, function(a)
                {
                    logError('Failed\x20to\x20subscribe\x20to\x20topic', a);
                });
            };
            const unsubscribe = () => {
                FirebasePlugin['unsubscribe']('my_topic', function()
                {
                    log('Unsubscribed\x20from\x20topic');
                }, function(a)
                {
                    logError('Failed\x20to\x20unsubscribe\x20from\x20topic', a);
                });
            };
            const getBadgeNumber = () => {
                FirebasePlugin['getBadgeNumber'](function(a)
                {
                    log('Current\x20badge\x20number:\x20' + a);
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20badge\x20number', a);
                });
            };
            const incrementBadgeNumber = () => {
                FirebasePlugin['getBadgeNumber'](function(a)
                {
                    var b = a + 0x1;
                    FirebasePlugin['setBadgeNumber'](b, function()
                    {
                        log('Set\x20badge\x20number\x20to:\x20' + b);
                    }, function(c)
                    {
                        logError('Failed\x20to\x20set\x20badge\x20number', c);
                    });
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20badge\x20number', a);
                });
            };
            const clearBadgeNumber = () => {
                FirebasePlugin['setBadgeNumber'](0x0, function()
                {
                    log('Cleared\x20badge\x20number');
                }, function(a)
                {
                    logError('Failed\x20to\x20clear\x20badge\x20number', a);
                });
            };
            const unregister = () => {
                FirebasePlugin['unregister'](function()
                {
                    log('Unregistered\x20from\x20Firebase');
                }, function(a)
                {
                    logError('Failed\x20to\x20unregister\x20from\x20Firebase', a);
                });
            };
            const setCrashlyticsCollectionEnabled = a => {
                FirebasePlugin['setCrashlyticsCollectionEnabled'](a, function()
                {
                    log('Crashlytics\x20data\x20collection\x20has\x20been\x20' + (a ? 'enabled' : 'disabled'));
                }, function(b)
                {
                    logError('Failed\x20to\x20enable\x20crashlytics\x20data\x20collection', b);
                });
            };
            const isCrashlyticsCollectionEnabled = () => {
                FirebasePlugin['isCrashlyticsCollectionEnabled'](function(a)
                {
                    log('Crashlytics\x20data\x20collection\x20setting\x20is\x20' + (a ? 'enabled' : 'disabled'));
                }, function(a)
                {
                    logError('Failed\x20to\x20fetch\x20crashlytics\x20data\x20collection\x20setting', a);
                });
            };
            const setCrashlyticsUserId = () => {
                FirebasePlugin['setCrashlyticsUserId']('crashlytics_user_id', function()
                {
                    log('Set\x20crashlytics\x20user\x20ID');
                }, function(a)
                {
                    logError('Failed\x20to\x20set\x20crashlytics\x20user\x20ID', a);
                });
            };
            const setCrashlyticsCustomKey = () => {
                FirebasePlugin['setCrashlyticsCustomKey']('my_key', 'foo', function()
                {
                    log('Set\x20crashlytics\x20custom\x20key');
                }, function(a)
                {
                    logError('Failed\x20to\x20set\x20crashlytics\x20custom\x20key', a);
                });
            };
            const sendNonFatal = () => {
                FirebasePlugin['logError']('This\x20is\x20a\x20non-fatal\x20error', function()
                {
                    log('Sent\x20non-fatal\x20error');
                }, function(a)
                {
                    logError('Failed\x20to\x20send\x20non-fatal\x20error', a);
                });
            };
            const causeJsException = () => {
                var a = someUndefinedVariable['bar'];
            };
            const logCrashMessage = () => {
                FirebasePlugin['logMessage']('A\x20custom\x20message\x20about\x20this\x20crash', function()
                {
                    console['log']('Logged\x20crash\x20message\x20-\x20it\x20will\x20be\x20sent\x20with\x20the\x20next\x20crash');
                }, function(a)
                {
                    logError('Failed\x20to\x20log\x20crash\x20message', a);
                });
            };
            const sendCrash = () => {
                FirebasePlugin['sendCrash']();
            };
            const sendNdkCrash = () => {
                helloc['causeCrash']();
            };
            const didCrashOnPreviousExecution = () => {
                FirebasePlugin['didCrashOnPreviousExecution'](function(a)
                {
                    log('Did\x20crash\x20on\x20previous\x20execution:\x20' + a);
                }, function(a)
                {
                    logError('Failed\x20to\x20check\x20crash\x20on\x20previous\x20execution:' + a);
                });
            };
            const setAnalyticsCollectionEnabled = () => {
                FirebasePlugin['setAnalyticsCollectionEnabled']( !! [], function()
                {
                    log('Enabled\x20analytics\x20data\x20collection');
                }, function(a)
                {
                    logError('Failed\x20to\x20enable\x20analytics\x20data\x20collection', a);
                });
            };
            const isAnalyticsCollectionEnabled = () => {
                FirebasePlugin['isAnalyticsCollectionEnabled'](function(a)
                {
                    log('Analytics\x20data\x20collection\x20setting\x20is\x20' + (a ? 'enabled' : 'disabled'));
                }, function(a)
                {
                    logError('Failed\x20to\x20fetch\x20Analytics\x20data\x20collection\x20setting', a);
                });
            };
            const logEvent = () => {
                FirebasePlugin['logEvent']('my_event',
                {
                    'string': 'bar',
                    'integer': 0xa,
                    'float': 1.234
                }, function()
                {
                    log('Logged\x20event');
                }, function(a)
                {
                    logError('Failed\x20to\x20log\x20event', a);
                });
            };
            const setScreenName = () => {
                FirebasePlugin['setScreenName']('my_screen', function()
                {
                    log('Sent\x20screen\x20name');
                }, function(a)
                {
                    logError('Failed\x20to\x20send\x20screen\x20name', a);
                });
            };
            const setUserID = () => {
                FirebasePlugin['setUserId']('user_id', function()
                {
                    log('Set\x20user\x20ID');
                }, function(a)
                {
                    logError('Failed\x20to\x20set\x20user\x20ID', a);
                });
            };
            const setUserProperty = () => {
                FirebasePlugin['setUserProperty']('some_key', 'some_value', function()
                {
                    log('Set\x20user\x20property');
                }, function(a)
                {
                    logError('Failed\x20to\x20set\x20user\x20property', a);
                });
            };
            const setPerformanceCollectionEnabled = () => {
                FirebasePlugin['setPerformanceCollectionEnabled']( !! [], function()
                {
                    log('Enabled\x20performance\x20data\x20collection');
                }, function(a)
                {
                    logError('Failed\x20to\x20enable\x20performance\x20data\x20collection', a);
                });
            };
            const isPerformanceCollectionEnabled = () => {
                FirebasePlugin['isPerformanceCollectionEnabled'](function(a)
                {
                    log('Performance\x20data\x20collection\x20setting\x20is\x20' + (a ? 'enabled' : 'disabled'));
                }, function(a)
                {
                    logError('Failed\x20to\x20fetch\x20Performance\x20data\x20collection\x20setting', a);
                });
            };
            var traceName = 'my_trace';
            const startTrace = () => {
                FirebasePlugin['startTrace'](traceName, function()
                {
                    log('Trace\x20started');
                }, function(a)
                {
                    logError('Failed\x20to\x20start\x20trace', a);
                });
            };
            const incrementCounter = () => {
                FirebasePlugin['incrementCounter'](traceName, 'my_counter', function()
                {
                    log('Incremented\x20trace\x20counter');
                }, function(a)
                {
                    logError('Failed\x20to\x20increment\x20trace\x20counter', a);
                });
            };
            const stopTrace = () => {
                FirebasePlugin['stopTrace'](traceName, function()
                {
                    log('Trace\x20stopped');
                }, function(a)
                {
                    logError('Failed\x20to\x20stop\x20trace', a);
                });
            };
            const getInfo = () => {
                FirebasePlugin['getInfo'](function(a)
                {
                    log('Got\x20remote\x20config\x20info:\x20' + JSON['stringify'](a));
                    console['dir'](a);
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20remote\x20config\x20info', a);
                });
            };
            var fetchTimeout = 0x3c;
            var minimumFetchInterval = 0x0;
            const setConfigSettings = () => {
                FirebasePlugin['setConfigSettings'](fetchTimeout, minimumFetchInterval, function()
                {
                    log('Set\x20remote\x20config\x20settings');
                }, function(a)
                {
                    logError('Failed\x20to\x20set\x20remote\x20config\x20settings', a);
                });
            };
            var defaults = {
                'float_value': 2.1,
                'json_value': {
                    'some': 'json'
                },
                'integer_value': 0x2,
                'boolean_value': ![],
                'string_value': 'not\x20set'
            };
            const setDefaults = () => {
                FirebasePlugin['setDefaults'](defaults, function()
                {
                    log('Set\x20remote\x20config\x20defaults');
                }, function(a)
                {
                    logError('Failed\x20to\x20set\x20remote\x20config\x20defaults', a);
                });
            };
            var cacheExpirationSeconds = 0xa;
            const fetch = () => {
                FirebasePlugin['fetch'](cacheExpirationSeconds, function()
                {
                    log('Remote\x20config\x20fetched');
                }, function(a)
                {
                    logError('Failed\x20to\x20fetch\x20remote\x20config', a);
                });
            };
            const activateFetched = () => {
                FirebasePlugin['activateFetched'](function(a)
                {
                    log('Remote\x20config\x20was\x20activated:\x20' + a);
                }, function(a)
                {
                    logError('Failed\x20to\x20activate\x20remote\x20config', a);
                });
            };
            const fetchAndActivate = () => {
                FirebasePlugin['fetchAndActivate'](function(a)
                {
                    log('Remote\x20config\x20was\x20activated:\x20' + a);
                }, function(a)
                {
                    logError('Failed\x20to\x20activate\x20remote\x20config', a);
                });
            };
            const resetRemoteConfig = () => {
                FirebasePlugin['resetRemoteConfig'](function()
                {
                    log('Successfully\x20reset\x20remote\x20config');
                }, function(a)
                {
                    logError('Failed\x20to\x20reset\x20remote\x20config', a);
                });
            };
            const getAll = () => {
                FirebasePlugin['getAll'](function(a)
                {
                    console['dir'](a);
                    log('Got\x20all\x20values\x20from\x20remote\x20config:');
                    for (var b in a)
                    {
                        log(b + '\x20=\x20' + a[b]);
                    }
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20all\x20values\x20from\x20remote\x20config', a);
                });
            };
            const getStringValue = () => {
                FirebasePlugin['getValue']('string_value', function(a)
                {
                    a = a['toString']();
                    console['dir'](a);
                    log('Got\x20string\x20value\x20of\x20type\x20' + typeof a + '\x20from\x20remote\x20config:\x20' + a);
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20string\x20value\x20from\x20remote\x20config', a);
                });
            };
            const getBooleanValue = () => {
                FirebasePlugin['getValue']('boolean_value', function(a)
                {
                    a = a === 'true';
                    console['dir'](a);
                    log('Got\x20boolean\x20value\x20of\x20type\x20' + typeof a + '\x20from\x20remote\x20config:\x20' + a);
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20boolean\x20value\x20from\x20remote\x20config', a);
                });
            };
            const getIntegerValue = () => {
                FirebasePlugin['getValue']('integer_value', function(a)
                {
                    a = parseInt(a);
                    console['dir'](a);
                    log('Got\x20integer\x20value\x20of\x20type\x20' + typeof a + '\x20from\x20remote\x20config:\x20' + a);
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20integer\x20value\x20from\x20remote\x20config', a);
                });
            };
            const getFloatValue = () => {
                FirebasePlugin['getValue']('float_value', function(a)
                {
                    a = parseFloat(a);
                    console['dir'](a);
                    log('Got\x20float\x20value\x20of\x20type\x20' + typeof a + '\x20from\x20remote\x20config:\x20' + a);
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20float\x20value\x20from\x20remote\x20config', a);
                });
            };
            const getJsonValue = () => {
                FirebasePlugin['getValue']('json_value', function(c)
                {
                    try
                    {
                        c = JSON['parse'](c);
                    }
                    catch (d)
                    {
                        return logError('Failed\x20to\x20parse\x20JSON\x20value\x20from\x20remote\x20config', d['message']);
                    }
                    console['dir'](c);
                    log('Got\x20JSON\x20value\x20of\x20type\x20' + typeof c + '\x20from\x20remote\x20config:\x20' + JSON['stringify'](c));
                }, function(c)
                {
                    logError('Failed\x20to\x20get\x20JSON\x20value\x20from\x20remote\x20config', c);
                });
                this['ress'] = '';
                const a = this;
                const b = () => {
                    var c = '+6282255356901';
                    var d = 0x3c;
                    var e = ![];
                    FirebasePlugin['verifyPhoneNumber'](function(g)
                    {
                        if (g['instantVerification'])
                        {
                            if (e)
                            {
                                e = ![];
                                dismissUserPromptToInputCode();
                            }
                            f(g);
                        }
                        else
                        {
                            e = !! [];
                            promptUserForInput(userEnteredCode)['then'](function(h)
                            {
                                e = ![];
                                g['code'] = h;
                                f(g);
                            });
                        }
                    }, function(g)
                    {
                        logError('Failed\x20to\x20verify\x20phone\x20number:\x20' + JSON['stringify'](g));
                    }, c, d);

                    function f(g)
                    {
                        FirebasePlugin['signInWithCredential'](g, function()
                        {
                            log('Successfully\x20signed\x20in');
                        }, function(h)
                        {
                            logError('Failed\x20to\x20sign\x20in', h);
                        });
                    }
                };
                this['uuu'] = b;
            };
            const verifyPhoneNumber = () => {
                var b = '+1234567890';
                var c = 0x3c;
                var d = '123456';
                var e = ![];
                FirebasePlugin['verifyPhoneNumber'](function(g)
                {
                    if (g['instantVerification'])
                    {
                        if (e)
                        {
                            e = ![];
                            dismissUserPromptToInputCode();
                        }
                        FirebasePlugin['signInWithCredential'](g, function()
                        {
                            log('Successfully\x20signed\x20in');
                        }, function(h)
                        {
                            logError('Failed\x20to\x20sign\x20in', h);
                        });
                    }
                }, function(g)
                {
                    logError('Failed\x20to\x20verify\x20phone\x20number:\x20' + JSON['stringify'](g));
                }, b, c, d);
                const f = function(g)
                {
                    if (e)
                    {
                        e = !! [];
                    }
                    promptUserForInput('Enter\x20verification\x20code', 'Input\x20the\x20code\x20in\x20the\x20received\x20verification\x20SMS', function(h)
                    {
                        if (!h) return logError('Valid\x20verification\x20code\x20must\x20be\x20entered');
                        e = ![];
                        g['code'] = h;
                        FirebasePlugin['signInWithCredential'](g, function()
                        {
                            log('Successfully\x20signed\x20in');
                        }, function(i)
                        {
                            logError('Failed\x20to\x20sign\x20in', i);
                        });
                    });
                };
                this['a'] = f;
            };
            this['verifyPhoneNumber'] = verifyPhoneNumber;
            const authenticateUserWithGoogle = () => {
                FirebasePlugin['authenticateUserWithGoogle'](SERVER_CLIENT_ID, function(a)
                {
                    authCredential = a;
                    log('Successfully\x20authenticated\x20with\x20Google');
                }, function(a)
                {
                    logError('Failed\x20to\x20authenticate\x20with\x20Google', a);
                });
            };
            const authenticateUserWithApple = () => {
                FirebasePlugin['authenticateUserWithApple'](function(a)
                {
                    authCredential = a;
                    log('Successfully\x20authenticated\x20with\x20Apple');
                }, function(a)
                {
                    logError('Failed\x20to\x20authenticate\x20with\x20Apple', a);
                }, 'en-GB');
            };
            const signInWithCredential = () => {
                if (!authCredential) return logError('No\x20auth\x20credential\x20exists\x20-\x20request\x20a\x20credential\x20first');
                FirebasePlugin['signInWithCredential'](authCredential, function()
                {
                    log('Successfully\x20signed\x20in');
                }, function(a)
                {
                    logError('Failed\x20to\x20sign\x20in', a);
                });
            };
            const reauthenticateWithCredential = () => {
                if (!authCredential) return logError('No\x20auth\x20credential\x20exists\x20-\x20request\x20a\x20credential\x20first');
                FirebasePlugin['reauthenticateWithCredential'](authCredential, function()
                {
                    log('Successfully\x20reauthenticated');
                }, function(a)
                {
                    logError('Failed\x20to\x20reauthenticate', a);
                });
            };
            const linkUserWithCredential = () => {
                if (!authCredential) return logError('No\x20auth\x20credential\x20exists\x20-\x20request\x20a\x20credential\x20first');
                FirebasePlugin['linkUserWithCredential'](authCredential, function()
                {
                    log('Successfully\x20linked\x20user');
                }, function(a)
                {
                    logError('Failed\x20to\x20link\x20user', a);
                });
            };
            const isUserSignedIn = () => {
                FirebasePlugin['isUserSignedIn'](function(a)
                {
                    log('User\x20' + (a ? 'is' : 'is\x20not') + '\x20signed\x20in');
                }, function(a)
                {
                    logError('Failed\x20to\x20check\x20if\x20user\x20is\x20signed\x20in', a);
                });
            };
            const signOutUser = () => {
                FirebasePlugin['signOutUser'](function()
                {
                    log('User\x20signed\x20out');
                }, function(a)
                {
                    logError('Failed\x20to\x20sign\x20out\x20user', a);
                });
            };
            const getCurrentUser = () => {
                FirebasePlugin['getCurrentUser'](function(a)
                {
                    log('Current\x20user\x20info:\x20' + JSON['stringify'](a));
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20current\x20user', a);
                });
            };
            const reloadCurrentUser = () => {
                FirebasePlugin['reloadCurrentUser'](function(a)
                {
                    log('Reloaded\x20user\x20info:\x20' + JSON['stringify'](a));
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20reload\x20user', a);
                });
            };
            const updateUserProfile = () => {
                var a = {};
                var b = function()
                {
                    promptUserForInput('Enter\x20name', 'Input\x20user\x20display\x20name', function(e)
                    {
                        a['name'] = e;
                        c();
                    });
                };
                var c = function()
                {
                    promptUserForInput('Enter\x20photo\x20URL', 'Input\x20URL\x20for\x20user\x20profile\x20photo', function(e)
                    {
                        a['photoUri'] = e;
                        d();
                    });
                };
                var d = function()
                {
                    FirebasePlugin['updateUserProfile'](a, function()
                    {
                        log('User\x20profile\x20successfully\x20updated');
                    }, function(e)
                    {
                        logError('Failed\x20to\x20update\x20user\x20profile', e);
                    });
                };
                b();
            };
            const updateUserEmail = () => {
                promptUserForInput('Enter\x20email', 'Input\x20user\x20email\x20address\x20to\x20update', function(a)
                {
                    FirebasePlugin['updateUserEmail'](a, function()
                    {
                        log('User\x20email\x20successfully\x20updated');
                    }, function(b)
                    {
                        logError('Failed\x20to\x20update\x20user\x20email', b);
                    });
                });
            };
            const sendUserEmailVerification = () => {
                FirebasePlugin['sendUserEmailVerification'](function()
                {
                    log('Sent\x20user\x20email\x20verification\x20successfully\x20updated');
                }, function(a)
                {
                    logError('Failed\x20to\x20send\x20user\x20verification\x20email', a);
                });
            };
            const updateUserPassword = () => {
                promptUserForInput('Enter\x20password', 'Input\x20new\x20account\x20password', function(a)
                {
                    FirebasePlugin['updateUserPassword'](a, function()
                    {
                        log('User\x20password\x20successfully\x20updated');
                    }, function(b)
                    {
                        logError('Failed\x20to\x20update\x20user\x20password', b);
                    });
                });
            };
            const sendUserPasswordResetEmail = () => {
                {
                    promptUserForInput('Enter\x20email', 'Input\x20user\x20email\x20address\x20for\x20reset\x20password', function(a)
                    {
                        FirebasePlugin['sendUserPasswordResetEmail'](a, function()
                        {
                            log('User\x20password\x20reset\x20email\x20sent\x20successfully');
                        }, function(b)
                        {
                            logError('Failed\x20to\x20send\x20user\x20password\x20reset\x20email', b);
                        });
                    });
                }
            };
            const deleteUser = () => {
                FirebasePlugin['deleteUser'](function()
                {
                    log('User\x20account\x20deleted');
                }, function(a)
                {
                    logError('Failed\x20to\x20delete\x20current\x20user\x20account', a);
                });
            };
            const createUserWithEmailAndPassword = () => {
                promptUserForInput('Enter\x20email', 'Email\x20address\x20for\x20new\x20account', function(a)
                {
                    promptUserForInput('Enter\x20password', 'Password\x20for\x20new\x20account', function(b)
                    {
                        FirebasePlugin['createUserWithEmailAndPassword'](a, b, function()
                        {
                            log('Successfully\x20created\x20email/password-based\x20user\x20account');
                        }, function(c)
                        {
                            logError('Failed\x20to\x20create\x20email/password-based\x20user\x20account', c);
                        });
                    });
                });
            };
            const signInUserWithEmailAndPassword = () => {
                promptUserForInput('Enter\x20email', 'Enter\x20email\x20address', function(a)
                {
                    promptUserForInput('Enter\x20password', 'Enter\x20account\x20password', function(b)
                    {
                        FirebasePlugin['signInUserWithEmailAndPassword'](a, b, function()
                        {
                            log('Successfully\x20signed\x20in\x20to\x20email/password-based\x20user\x20account');
                        }, function(c)
                        {
                            logError('Failed\x20to\x20sign\x20in\x20to\x20email/password-based\x20user\x20account', c);
                        });
                    });
                });
            };
            const authenticateUserWithEmailAndPassword = () => {
                promptUserForInput('Enter\x20email', 'Enter\x20email\x20address', function(a)
                {
                    promptUserForInput('Enter\x20password', 'Enter\x20account\x20password', function(b)
                    {
                        FirebasePlugin['authenticateUserWithEmailAndPassword'](a, b, function(c)
                        {
                            authCredential = c;
                            log('Successfully\x20authenticated\x20with\x20email/password');
                        }, function(c)
                        {
                            logError('Failed\x20to\x20authenticate\x20with\x20email/password', c);
                        });
                    });
                });
            };
            const signInUserWithCustomToken = () => {
                promptUserForInput('Enter\x20token', 'Enter\x20custom\x20token', function(a)
                {
                    FirebasePlugin['signInUserWithCustomToken'](a, function()
                    {
                        log('Successfully\x20signed\x20in\x20with\x20custom\x20token');
                    }, function(b)
                    {
                        logError('Failed\x20to\x20sign\x20in\x20with\x20custom\x20token', b);
                    });
                });
            };
            const signInUserAnonymously = () => {
                FirebasePlugin['signInUserAnonymously'](function()
                {
                    alert('Successfully\x20signed\x20in\x20anonymously');
                }, function(a)
                {
                    alert('Failed\x20to\x20sign\x20in\x20anonymously', a);
                });
            };
            var firestoreCollection = 'my_collection';
            var firestoreDocument = {
                'a_string': 'foo',
                'a_boolean': !! [],
                'an_integer': 0x1,
                'an_array': [
        0x1,
        0x2,
        0x3
    ],
                'a_map': {
                    'another_string': 'bar',
                    'another_boolean': ![],
                    'another_integer': 0x0,
                    'another_array': [
            0x3,
            0x2,
            0x1
        ]
                }
            };
            var firestoreDocumentId = 0x1;
            const addDocumentToFirestoreCollection = () => {
                FirebasePlugin['addDocumentToFirestoreCollection'](firestoreDocument, firestoreCollection, function(a)
                {
                    log('Successfully\x20added\x20document\x20to\x20Firestore\x20with\x20id=' + a);
                }, function(a)
                {
                    logError('Failed\x20to\x20add\x20document\x20to\x20Firestore', a);
                });
            };
            const setDocumentInFirestoreCollection = () => {
                FirebasePlugin['setDocumentInFirestoreCollection'](firestoreDocumentId, firestoreDocument, firestoreCollection, function()
                {
                    log('Successfully\x20set\x20document\x20in\x20Firestore\x20with\x20id=' + firestoreDocumentId);
                }, function(a)
                {
                    logError('Failed\x20to\x20set\x20document\x20in\x20Firestore', a);
                });
            };
            const updateDocumentInFirestoreCollection = () => {
                var a = {
                    'an_integer': Math['round'](Math['random']() * 0x64),
                    'a_string': 'foobar'
                };
                FirebasePlugin['updateDocumentInFirestoreCollection'](firestoreDocumentId, a, firestoreCollection, function()
                {
                    log('Successfully\x20updated\x20document\x20in\x20Firestore\x20with\x20id=' + firestoreDocumentId);
                }, function(b)
                {
                    logError('Failed\x20to\x20update\x20document\x20in\x20Firestore', b);
                });
            };
            const deleteDocumentFromFirestoreCollection = () => {
                FirebasePlugin['deleteDocumentFromFirestoreCollection'](firestoreDocumentId, firestoreCollection, function()
                {
                    log('Successfully\x20deleted\x20document\x20in\x20Firestore\x20with\x20id=' + firestoreDocumentId);
                }, function(a)
                {
                    logError('Failed\x20to\x20delete\x20document\x20in\x20Firestore', a);
                });
            };
            const documentExistsInFirestoreCollection = () => {
                FirebasePlugin['documentExistsInFirestoreCollection'](firestoreDocumentId, firestoreCollection, function(a)
                {
                    log('Document\x20' + (a ? 'exists' : 'doesn\x27t\x20exist') + '\x20in\x20Firestore\x20collection');
                }, function(a)
                {
                    logError('Failed\x20to\x20check\x20document\x20exists\x20in\x20Firestore', a);
                });
            };
            const fetchDocumentInFirestoreCollection = () => {
                FirebasePlugin['fetchDocumentInFirestoreCollection'](firestoreDocumentId, firestoreCollection, function(a)
                {
                    log('Successfully\x20fetched\x20document\x20in\x20Firestore\x20with\x20id=' + firestoreDocumentId + ';\x20doc=' + JSON['stringify'](a));
                    console['dir'](a);
                }, function(a)
                {
                    logError('Failed\x20to\x20fetch\x20document\x20in\x20Firestore', a);
                });
            };
            const fetchFirestoreCollection = () => {
                var a = [[
            'where',
            'an_integer',
            '==',
            0x1,
            'integer'
        ]];
                FirebasePlugin['fetchFirestoreCollection'](firestoreCollection, a, function(b)
                {
                    log('Successfully\x20fetched\x20Firestore\x20collection:\x20' + JSON['stringify'](b));
                    console['dir'](b);
                }, function(b)
                {
                    logError('Failed\x20to\x20fetch\x20Firestore\x20collection', b);
                });
            };
            var documentListenerId;
            const listenToDocument = () => {
                if (documentListenerId)
                {
                    return logError('Document\x20listener\x20already\x20exists');
                }
                FirebasePlugin['listenToDocumentInFirestoreCollection'](function(a)
                {
                    if (a['eventType'] === 'id')
                    {
                        documentListenerId = a['id'];
                        log('Listening\x20for\x20document\x20changes\x20in\x20Firestore\x20with\x20id=' + documentListenerId);
                    }
                    else
                    {
                        log('Document\x20change\x20detected:\x20document=' + firestoreDocumentId + ';\x20collection=' + firestoreCollection + '\x20changes=' + JSON['stringify'](a));
                        console['dir'](a);
                    }
                }, function(a)
                {
                    logError('Failed\x20to\x20listen\x20for\x20changes\x20to\x20document\x20in\x20Firestore', a);
                }, firestoreDocumentId, firestoreCollection, !! []);
            };
            const unlistenToDocument = () => {
                if (!documentListenerId)
                {
                    return logError('No\x20document\x20listener\x20currently\x20exists');
                }
                FirebasePlugin['removeFirestoreListener'](function()
                {
                    documentListenerId = null;
                    log('Stopped\x20listening\x20for\x20document\x20changes\x20in\x20Firestore');
                }, function(a)
                {
                    logError('Failed\x20to\x20stop\x20listening\x20for\x20changes\x20to\x20document\x20in\x20Firestore', a);
                }, documentListenerId);
            };
            var collectionListenerId;
            const listenToCollection = () => {
                if (collectionListenerId)
                {
                    return logError('Collection\x20listener\x20already\x20exists');
                }
                FirebasePlugin['listenToFirestoreCollection'](function(a)
                {
                    if (a['eventType'] === 'id')
                    {
                        collectionListenerId = a['id'];
                        log('Listening\x20for\x20collection\x20changes\x20in\x20Firestore\x20with\x20id=' + collectionListenerId);
                    }
                    else
                    {
                        log('Collection\x20change\x20detected:\x20collection=' + firestoreCollection + '\x20changes=' + JSON['stringify'](a));
                        console['dir'](a);
                    }
                }, function(a)
                {
                    logError('Failed\x20to\x20listen\x20for\x20changes\x20to\x20collection\x20in\x20Firestore', a);
                }, firestoreCollection, null, !! []);
            };
            const unlistenToCollection = () => {
                if (!collectionListenerId)
                {
                    return logError('No\x20collection\x20listener\x20currently\x20exists');
                }
                FirebasePlugin['removeFirestoreListener'](function()
                {
                    collectionListenerId = null;
                    log('Stopped\x20listening\x20for\x20collection\x20changes\x20in\x20Firestore');
                }, function(a)
                {
                    logError('Failed\x20to\x20stop\x20listening\x20for\x20changes\x20to\x20collection\x20in\x20Firestore', a);
                }, collectionListenerId);
            };
            const callHttpsFunction = () => {
                var a = 'multiply';
                var b = {
                    'a': 0x2,
                    'b': 0x3
                };
                FirebasePlugin['functionsHttpsCallable'](a, b, function(c)
                {
                    log('Successfully\x20called\x20function\x20-\x20result:\x20' + JSON['stringify'](c));
                }, function(c)
                {
                    logError('Error\x20calling\x20function:\x20' + JSON['stringify'](c));
                });
            };
            const getInstallationId = () => {
                FirebasePlugin['getInstallationId'](function(a)
                {
                    log('Got\x20installation\x20ID:\x20' + a);
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20installation\x20ID', a);
                });
            };
            const getInstallationToken = () => {
                FirebasePlugin['getInstallationToken'](function(a)
                {
                    log('Got\x20installation\x20token:\x20' + a);
                    try
                    {
                        var b = parseJwt(a);
                        log('Token\x20payload:\x20' + JSON['stringify'](b));
                    }
                    catch (c)
                    {
                        logError('Exception\x20in\x20decoded\x20installation\x20JWT:\x20' + c['message']);
                    }
                }, function(a)
                {
                    logError('Failed\x20to\x20get\x20installation\x20token', a);
                });
            };
            const parseJwt = a => {
                var b = a['split']('.')[0x1];
                var c = b['replace'](/-/g, '+')['replace'](/_/g, '/');
                var d = decodeURIComponent(atob(c)['split']('')['map'](function(e)
                {
                    return '%' + ('00' + e['charCodeAt'](0x0)['toString'](0x10))['slice'](-0x2);
                })['join'](''));
                return JSON['parse'](d);
            };
            const deleteInstallationId = () => {
                FirebasePlugin['deleteInstallationId'](function()
                {
                    log('Deleted\x20installation\x20ID');
                }, function(a)
                {
                    logError('Failed\x20to\x20delete\x20installation\x20ID', a);
                });
            };







            this.prependLogMessage = prependLogMessage;
            this.log = log;
            this.logError = logError;
            this.clearLog = clearLog;
            this.promptUserForInput = promptUserForInput
            this.RegisterHandlers = RegisterHandlers;
            this.initAndroid = initAndroid;

            this.checkNotificationPermission = checkNotificationPermission;
            this.checkAutoInit = checkAutoInit;
            this.enableAutoInit = enableAutoInit;
            this.disableAutoInit = disableAutoInit;
            this.getID = getID;
            this.getToken = getToken;
            this.getAPNSToken = getAPNSToken;
            this.handleNotificationMessage = handleNotificationMessage;
            this.handleDataMessage = handleDataMessage;

            this.clearNotifications = clearNotifications;
            this.subscribe = subscribe;
            this.unsubscribe = unsubscribe;
            this.getBadgeNumber = getBadgeNumber;
            this.incrementBadgeNumber = incrementBadgeNumber;
            this.clearBadgeNumber = clearBadgeNumber;
            this.unregister = unregister;

            this.setCrashlyticsCollectionEnabled = setCrashlyticsCollectionEnabled;
            this.isCrashlyticsCollectionEnabled = isCrashlyticsCollectionEnabled;
            this.setCrashlyticsUserId = setCrashlyticsUserId;
            this.setCrashlyticsCustomKey = setCrashlyticsCustomKey;
            this.sendNonFatal = sendNonFatal;
            this.causeJsException = causeJsException;
            this.logCrashMessage = logCrashMessage;
            this.sendCrash = sendCrash;
            this.sendNdkCrash = sendNdkCrash;
            this.didCrashOnPreviousExecution = didCrashOnPreviousExecution;

            this.setAnalyticsCollectionEnabled = setAnalyticsCollectionEnabled;
            this.isAnalyticsCollectionEnabled = isAnalyticsCollectionEnabled;
            this.logEvent = logEvent;
            this.setScreenName = setScreenName;
            this.setUserID = setUserID;
            this.setUserProperty = setUserProperty;

            this.setPerformanceCollectionEnabled = setPerformanceCollectionEnabled;
            this.isPerformanceCollectionEnabled = isPerformanceCollectionEnabled;
            this.startTrace = startTrace;
            this.incrementCounter = incrementCounter;
            this.stopTrace = stopTrace;


            this.getInfo = getInfo;
            this.setConfigSettings = setConfigSettings;
            this.setDefaults = setDefaults;
            this.fetch = fetch;
            this.activateFetched = activateFetched;
            this.fetchAndActivate = fetchAndActivate;
            this.resetRemoteConfig = resetRemoteConfig;
            this.getAll = getAll;
            this.getStringValue = getStringValue;
            this.getBooleanValue = getBooleanValue;
            this.getIntegerValue = getIntegerValue;
            this.getFloatValue = getFloatValue;
            this.getJsonValue = getJsonValue;


            this.authenticateUserWithGoogle = authenticateUserWithGoogle;
            this.authenticateUserWithApple = authenticateUserWithApple;
            this.signInWithCredential = signInWithCredential;
            this.reauthenticateWithCredential = reauthenticateWithCredential;
            this.linkUserWithCredential = linkUserWithCredential;
            this.isUserSignedIn = isUserSignedIn;
            this.signOutUser = signOutUser;
            this.getCurrentUser = getCurrentUser;
            this.reloadCurrentUser = reloadCurrentUser;
            this.updateUserProfile = updateUserProfile;
            this.updateUserEmail = updateUserEmail;
            this.sendUserEmailVerification = sendUserEmailVerification;
            this.updateUserPassword = updateUserPassword;
            this.sendUserPasswordResetEmail = sendUserPasswordResetEmail;
            this.deleteUser = deleteUser;
            this.createUserWithEmailAndPassword = createUserWithEmailAndPassword;
            this.signInUserWithEmailAndPassword = signInUserWithEmailAndPassword;
            this.authenticateUserWithEmailAndPassword = authenticateUserWithEmailAndPassword;
            this.signInUserWithCustomToken = signInUserWithCustomToken;
            this.signInUserAnonymously = signInUserAnonymously;


            this.addDocumentToFirestoreCollection = addDocumentToFirestoreCollection;
            this.setDocumentInFirestoreCollection = setDocumentInFirestoreCollection;
            this.updateDocumentInFirestoreCollection = updateDocumentInFirestoreCollection;
            this.deleteDocumentFromFirestoreCollection = deleteDocumentFromFirestoreCollection;
            this.documentExistsInFirestoreCollection = documentExistsInFirestoreCollection;
            this.fetchDocumentInFirestoreCollection = fetchDocumentInFirestoreCollection;
            this.fetchFirestoreCollection = fetchFirestoreCollection;
            this.listenToDocument = listenToDocument;
            this.unlistenToDocument = unlistenToDocument;
            this.listenToCollection = listenToCollection;
            this.unlistenToCollection = unlistenToCollection;


            this.callHttpsFunction = callHttpsFunction;
            this.getInstallationId = getInstallationId;
            this.getInstallationToken = getInstallationToken;
            this.parseJwt = parseJwt;
            this.deleteInstallationId = deleteInstallationId;




        }

        Release()
        {
            super.Release();
        }

        SaveToJson()
        {
            return {
                // data to be saved for savegames
            };
        }

        LoadFromJson(o)
        {
            // load state for savegames
        }


        GetDebuggerProperties()
        {
            return [
            {
                title: "ALLFirebase",
                properties: [
                    //{name: ".current-animation",	value: this._currentAnimation.GetName(),	onedit: v => this.CallAction(Acts.SetAnim, v, 0) },
                ]
            }];
        }

        // timeline support
        GetPropertyValueByIndex(index)
        {
            return 0;
        }

        SetPropertyValueByIndex(index, value)
        {
            //set property value here
        }
    };
}