"use strict";
{
    const SDK = self.SDK;

    const PLUGIN_ID = "EMI_INDO_ALLFirebase";
    const PLUGIN_VERSION = "1.1.0.8";
    const PLUGIN_CATEGORY = "web";

    const PLUGIN_CLASS = SDK.Plugins.EMI_INDO_ALLFirebase = class ALLFirebasePlugin extends SDK.IPluginBase
    {
        constructor()
        {
            super(PLUGIN_ID);

            SDK.Lang.PushContext("plugins." + PLUGIN_ID.toLowerCase());

            this._info.SetName(lang(".name"));
            this._info.SetDescription(lang(".description"));
            this._info.SetVersion(PLUGIN_VERSION);
            this._info.SetCategory(PLUGIN_CATEGORY);
            this._info.SetAuthor("EMI_INDO");
            this._info.SetHelpUrl(lang(".help-url"));
            this._info.SetIsSingleGlobal(true);
            this._info.SetCanBeBundled(true);

            this._info.SetSupportedRuntimes(["c3"]);

            this._info.SetAndroidXEnabled(true);
			this._info.SetGooglePlayServicesEnabled(true);




            const SERVERCLIENTID = new SDK.PluginProperty("text", "SERVER-CLIENT-ID", "OAuth 2.0 web client ID");
            const path = new SDK.PluginProperty("text", "ANDROID-FIREBASE-CONFIG-FILEPATH", "www/google-services.json");


            const TAGMANAGER = new SDK.PluginProperty("text", "ANDROID-PLAY-SERVICES-TAGMANAGER-VERSION", "18.0.2");
            const SERVICESAUTH = new SDK.PluginProperty("text", "ANDROID-PLAY-SERVICES-AUTH-VERSION", "20.4.0");
            const MESSAGING = new SDK.PluginProperty("text", "ANDROID-FIREBASE-MESSAGING-VERSION", "23.1.0");
            const CONFIG = new SDK.PluginProperty("text", "ANDROID-FIREBASE-CONFIG-VERSION", "21.2.0");
            const AUTH = new SDK.PluginProperty("text", "ANDROID-FIREBASE-AUTH-VERSION", "21.1.0");
            const FIRESTORE = new SDK.PluginProperty("text", "ANDROID-FIREBASE-FIRESTORE-VERSION", "24.4.1");
            const FUNCTIONS = new SDK.PluginProperty("text", "ANDROID-FIREBASE-FUNCTIONS-VERSION", "20.2.1");
            const IID = new SDK.PluginProperty("text", "ANDROID-FIREBASE-IID-VERSION", "21.1.0");
            const INSTALLATIONS = new SDK.PluginProperty("text", "ANDROID-FIREBASE-INSTALLATIONS-VERSION", "17.1.0");
            const GSON = new SDK.PluginProperty("text", "ANDROID-GSON-VERSION", "2.9.0");

            const android = new SDK.PluginProperty("text", "ANDROID-FIREBASE-ANALYTICS-VERSION", "21.2.0");
            const PERF = new SDK.PluginProperty("text", "ANDROID-FIREBASE-PERF-VERSION", "20.3.0");
            const d = new SDK.PluginProperty("text", "ANDROID-FIREBASE-INAPPMESSAGING-VERSION", "20.2.0");
            const e = new SDK.PluginProperty("text", "ANDROID-FIREBASE-CRASHLYTICS-NDK-VERSION", "18.3.2");
            const f = new SDK.PluginProperty("text", "ANDROID-FIREBASE-PERF-GRADLE-PLUGIN-VERSION", "1.4.2");
            const pathios = new SDK.PluginProperty("text", "IOS-FIREBASE-CONFIG-FILEPATH", "www/GoogleService-Info.plist");
            const a = new SDK.PluginProperty("combo", "FIREBASE-ANALYTICS-COLLECTION-ENABLED",
            {
                initialValue: "true",
                items: ["true", "false"]
            });
            const b = new SDK.PluginProperty("combo", "FIREBASE-PERFORMANCE-COLLECTION-ENABLED",
            {
                initialValue: "true",
                items: ["true", "false"]
            });
            const c = new SDK.PluginProperty("combo", "FIREBASE-CRASHLYTICS-COLLECTION-ENABLED",
            {
                initialValue: "true",
                items: ["true", "false"]
            });



            SDK.Lang.PushContext(".properties");

            this._info.SetProperties([
            SERVERCLIENTID,
            new SDK.PluginProperty("group", "Firebase-config-setup-android"),
            path,
            TAGMANAGER,
            SERVICESAUTH,
            MESSAGING,
            CONFIG,
            AUTH,
            FIRESTORE,
            FUNCTIONS,
            IID,
            INSTALLATIONS,
            GSON,
            android,
            PERF,
            d,
            e,
            f,
            new SDK.PluginProperty("group", "Firebase-config-setup-ios"),
            pathios,
            new SDK.PluginProperty("group", "Firebase-SETUP-Variable"),
            a,
            b,
            c,
            ]);



            this._info.AddCordovaPluginReference(
            {
                id: "cordova-plugin-firebasex",
                plugin: this,
                version: "16.0.0",
                variables: [
                        ["SERVER_CLIENT_ID", SERVERCLIENTID],
                        ["ANDROID_FIREBASE_CONFIG_FILEPATH", path],
                        ["ANDROID_PLAY_SERVICES_TAGMANAGER_VERSION", TAGMANAGER],
                        ["ANDROID_PLAY_SERVICES_AUTH_VERSION", SERVICESAUTH],
                           ["ANDROID_FIREBASE_MESSAGING_VERSION", MESSAGING],
                        ["ANDROID_FIREBASE_CONFIG_VERSION", CONFIG],
                        ["ANDROID_FIREBASE_AUTH_VERSION", AUTH],
                        ["ANDROID_FIREBASE_FIRESTORE_VERSION", FIRESTORE],
                        ["ANDROID_FIREBASE_FUNCTIONS_VERSION", FUNCTIONS],
                        ["ANDROID_FIREBASE_IID_VERSION", IID],
                        ["ANDROID_FIREBASE_INSTALLATIONS_VERSION", INSTALLATIONS],
                        ["ANDROID_GSON_VERSION", GSON],
                        ["ANDROID_FIREBASE_ANALYTICS_VERSION", android],
                        ["ANDROID_FIREBASE_PERF_VERSION", PERF],
                        ["ANDROID_FIREBASE_INAPPMESSAGING_VERSION", d],
                        ["ANDROID_FIREBASE_CRASHLYTICS_NDK_VERSION", e],
                        ["ANDROID_FIREBASE_PERF_GRADLE_PLUGIN_VERSION", f],
                        ["IOS_FIREBASE_CONFIG_FILEPATH", pathios],
                        ["FIREBASE_ANALYTICS_COLLECTION_ENABLED", a],
                        ["FIREBASE_PERFORMANCE_COLLECTION_ENABLED", b],
                        ["FIREBASE_CRASHLYTICS_COLLECTION_ENABLED", c],
                    ],


            });


            this._info.AddCordovaPluginReference(
            {
                id: "cordova-plugin-dialogs"
            });

            SDK.Lang.PopContext(); //.properties
            SDK.Lang.PopContext();
        }
    };

    PLUGIN_CLASS.Register(PLUGIN_ID, PLUGIN_CLASS);
}